package com.example.blinddrive;

import ioio.lib.api.DigitalOutput;
import ioio.lib.api.PwmOutput;
import ioio.lib.api.exception.ConnectionLostException;
import ioio.lib.util.BaseIOIOLooper;
import ioio.lib.util.IOIOLooper;
import ioio.lib.util.android.IOIOActivity;

import android.widget.ToggleButton;
import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;

public class BlindDriveActivity extends IOIOActivity {
	boolean ledFlag = false;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_blind_drive);
    }

	class Looper extends BaseIOIOLooper {
		private DigitalOutput led_;			/** The on-board LED. */
		private PwmOutput turnOutput_;		// pwm output for turn motor
		private PwmOutput pwrOutput_;		// pwm output for drive motor

		/**
		 * Called every time a connection with IOIO has been established.
		 * Typically used to open pins.
		 * 
		 * @throws ConnectionLostException
		 *             When IOIO connection is lost.
		 * 
		 * @see ioio.lib.util.AbstractIOIOActivity.IOIOThread#setup()
		 */
		@Override
		protected void setup() throws ConnectionLostException {
			led_ = ioio_.openDigitalOutput(0, true);
			turnOutput_ = ioio_.openPwmOutput(12, 100);
			pwrOutput_ = ioio_.openPwmOutput(14, 100);
		}

		/**
		 * Called repetitively while the IOIO is connected.
		 * 
		 * @throws ConnectionLostException
		 *             When IOIO connection is lost.
		 * 
		 * @see ioio.lib.util.AbstractIOIOActivity.IOIOThread#loop()
		 */
		@Override
		public void loop() throws ConnectionLostException {
			turnOutput_.setPulseWidth(1400);		// Hard Left: 2000, Straight: 1400, Hard Right: 1000
			pwrOutput_.setPulseWidth(1670);			// Fast Forward: 2500, Stop: 1540, Fast Reverse: 500
			led_.write(ledFlag);
			
			ledFlag = !ledFlag;
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
			}
		}
	}

	/**
	 * A method to create our IOIO thread.
	 * 
	 * @see ioio.lib.util.AbstractIOIOActivity#createIOIOThread()
	 */
	protected IOIOLooper createIOIOLooper() {
		return new Looper();
	}

    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_blind_drive, menu);
        return true;
    }
}
